Subject: Re: Device tree aware EMAC driver

From: David Gibson <[email-masked]>
Date: Wed, 8 Aug 2007 11:18:23 +1000

On Tue, Aug 07, 2007 at 07:15:39AM -0500, Josh Boyer wrote:
> On Tue, 7 Aug 2007 16:22:31 +1000
> David Gibson <[email-masked]> wrote:
> 
> > Based on BenH's earlier work, this is a new version of the EMAC driver
> > for the built-in ethernet found on PowerPC 4xx embedded CPUs.  The
> > same ASIC is also found in the Axon bridge chip.  This new version is
> > designed to work in the arch/powerpc tree, using the device tree to
> > probe the device, rather than the old and ugly arch/ppc OCP layer.
> > 
> > This driver is designed to sit alongside the old driver (it lies in
> > drivers/net/ibm_emac and this one in drivers/net/ibm_newemac).  The
> > old driver is left in place to support arch/ppc until arch/ppc itself
> > reaches its final demise (not too long now, with luck).
> > 
> > This driver still has a number of things that could do with cleaning
> > up, but I think they can be fixed up after merging.  Specifically:
> > 	- Should be adjusted to properly use the dma mapping API.
> > Axon needs this.
> > 	- Probe logic needs reworking, in conjuction with the general
> > probing code for of_platform devices.  The dependencies here between
> > EMAC, MAL, ZMII etc. make this complicated.  At present, it usually
> > works, because we initialize and register the sub-drivers before the
> > EMAC driver itself, and (being in driver code) runs after the devices
> > themselves have been instantiated from the device tree.
> > 
> > Signed-off-by: David Gibson <[email-masked]>
> 
> Hm.  Should this go through Jeff Garzik or Paul?  If it's the latter,
> I'll pull this into my git tree soon.

Through Jeff Garzik, I think.  I was planning to send it to him today
or tomorrow if there are no screams from the linuxppc-dev list.

-- 
David Gibson			| I'll have my music baroque, and my code
david AT gibson.dropbear.id.au	| minimalist, thank you.  NOT _the_ _other_
				| _way_ _around_!
http://www.ozlabs.org/~dgibson